package xmlchecker;

import javax.swing.tree.DefaultMutableTreeNode;

/**
  Knoten im XML-Baum
*/
public class XMLTreeNode extends DefaultMutableTreeNode{
/**
  Knotentyp nicht fest gelegt
*/
  public static final int UNDEFINED = 0;
/**
  Knoten entspricht dem XML-Dokument
*/
  public static final int DOCUMENT = 1;
/**
  Knoten entspricht einem Element
*/
  public static final int ELEMENT = 2;
/**
  Knoten entspricht einem Attribut
*/
  public static final int ATTRIBUTE = 3;
/**
  Knoten entspricht einem Zeicheninhalt
*/
  public static final int CHARACTERS = 4;
/**
  Knoten entspricht einer Verarbeitungsanweisung
*/
  public static final int PI = 5;

  private int type;

/**
  Neuer Knoten mit angegebenen Text und Typ
  @param   text   Knotentext
  @param   type   Knotentyp
*/
  public XMLTreeNode(String text, int type){
    super(text);
    this.setType(type);
  }
/**
  Standardkknoten
*/
  public XMLTreeNode(){
    this("", XMLTreeNode.UNDEFINED);
  }

/**
  Der Typ des Knotens
  @param   type   Kennzahl fr den Typ
*/
  public void setType(int type){
    this.type = type;
  }
/**
  Der Typ des Knotens
  @return  Kennzahl fr den Typ
*/
  public int getType(){
    return this.type;
  }

/**
  Der Text des Knotens
  @param   text   der Text
*/
  public void setText(String text){
    this.setUserObject(text);
  }
/**
  Der Text des Knotens
  @return  der Text
*/
  public String getText(){
    return String.valueOf(this.getUserObject());
  }
}