package xmlchecker.sax;

import java.net.URI;
import java.net.URISyntaxException;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class SAXCheckerErrorHandler implements ErrorHandler{
  private StringBuffer messages;

  public SAXCheckerErrorHandler(StringBuffer messages){
    this.messages = messages;
  }

  public void warning(SAXParseException ex) throws SAXException {

    messages.append("Warnung:" + locationAsString(ex) + ex.getMessage() + '\n');
  }

  public void error(SAXParseException ex) throws SAXException {
    messages.append("Fehler:" + locationAsString(ex) + ex.getMessage() + '\n');
  }

  public void fatalError(SAXParseException ex) throws SAXException {
    messages.append("Schwerer Fehler:" + locationAsString(ex) + ex.getMessage() + '\n');
  }

  public static String locationAsString(SAXParseException spex){
    String loc = " [";
    if(spex.getSystemId()!=null){
      try{
        String path = new URI(spex.getSystemId()).getPath();
        loc = loc + path.substring(path.lastIndexOf("/")+1, path.length()) + " - ";
      }catch(Exception ex){
        loc = loc + spex.getSystemId() + " - ";
      }
    } else {
      if(spex.getPublicId()!=null){
        loc = loc + spex.getPublicId() + " - ";
      }
    }
    loc = loc + spex.getLineNumber() + ", " + spex.getColumnNumber() + "] ";
    return loc;
  }
}
